<?php

/*

 $Id: help.php,v 1.16 2003/08/13 17:23:51 vollmerk Exp $
 $Source: /data/cvsroot/maintain/modules/class/help.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Help Documents Class
	The class for the built in help files (retrived from mysql table) this will 
	pushed into libglue eventualy...

*/

class Help {
	var $id;
	var $ident;
	var $content;

	/* Array to store reused help docs */
	var $cache;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Help ( $help_ident =0 ) {
		global $conf;

		$this->ident = $help_ident;

		//don't care about it if there isn't a ident
		if ($help_ident) {
			$info = $this->get_info();
			// set all of the objects attributes
			$this->id	= $info->id;
			$this->content	= stripslashes($info->content);
		} //if help

		if ( ! $info ) {
			return false;
		}

	} // Help 
	function get_info () {
		global $conf;

		$sql = "SELECT * FROM help WHERE ident='$this->ident'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

	//Gets the set ident, more then get info because it stores it in the cache
	function get_help($help_ident) {
		global $conf;

		//First check the cache and return if it's there
		if (isset($this->cache[$help_ident])) {
			$this->content = $this->cache[$help_ident];
		}
		else { 
			$sql = "SELECT content FROM help WHERE ident='$help_ident'";
			$db_results = mysql_query($sql, $conf['dbh']);
			$results = mysql_fetch_object($db_results);
			$this->content = stripslashes($results->content);

			/* Now store this help doc */
			$this->cache[$help_ident] = $this->content;

		}


	} //get_help
	
	//just display the help document, no fancy mojo
	function display_help($help_ident) {
		global $conf;

		$this->get_help($help_ident);
		echo "<p>\n$this->content\n</p>\n\n";

	} //display_help

	// This function is depreicated
	function display_plain_txt($help_ident) {

		$this->title($help_ident);

	}

	/*!
		@function title
		@discussion shows text formated to fit inside the title tag, 
			replaced the display_plain_txt function
	*/
	function title($help_ident) { 

		$this->get_help($help_ident);
		$this->content = strip_tags($this->content);
		if (!substr_count($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
			$this->content = preg_replace('/\\n|\\r|\\t/',' ',$this->content);
		}
		echo $this->content;

	} // title

	// Function to add a help document, requires ident and content
	function add_help ($help_ident, $help_content) 
	{
		global $conf, $user;

		// Make sure they are turley a administrator
		if (!$user->is_admin) 
			{ 
			$conf['error']->add_error('help_new', 'Error Creating new help document, you do not have sufficant privledges');
			return false; 
			}

		// add the required slashes to the varb so that when we enter it into the db it's mojo isn't foobed
		$help_content = addslashes($help_content);

		// check to make sure that the specified ident isn't in there already
		$sql = "SELECT * FROM help WHERE ident='$help_ident'";
		$db_results = mysql_query($sql, $conf['dbh']);
		$help = mysql_fetch_object($db_results);
		if ($help->ident <= " ") 
			{
			// dump it into the database
			$sql = "INSERT INTO help SET ident='$help_ident', content='$help_content'";
			$db_results = mysql_query($sql, $conf['dbh']);
			echo mysql_error();
			if ($db_results) { return true; }
			else 
				{ 
				$error = mysql_error();
				$conf['error']->add_error('help_new','Error Updating', "The following error occured while trying to update $help_ident $error");
				}
			}
	} // add_help

	// Update help, requires ident and content
	function update_help ($help_ident, $help_content)
	{
		global $conf, $user;

		// Make sure they are truely a administrator
		if (!$user->is_admin) 
			{ 
			$conf['error']->add_error('help_update', "Error Updating Help Document, you do not have sufficant privledges");
			return false;
			}
		// Add the required slashes
		$help_content = addslashes($help_content);
		// Update into database
		$sql = "UPDATE help SET content='$help_content' WHERE ident='$help_ident'";
		$db_results = mysql_query($sql, $conf['dbh']);
		// If unable to update then create a new error
		if (!$db_results) 
			{
			$error = mysql_error();
			$conf['error']->add_error('help_update', "Error Updating $help_ident", "The following error occured while trying to update $help_ident $error");
			}
	} // update_help
	
	// View all help documents 
	function view_help($sql)
	{
		global $conf, $user;
		$help_objects = array();
		// Make sure they are an administrator
		if (!$user->is_admin)
			{
			$conf['error']->add_error('help_view', "Error Viewing help document you do not have sufficant privledges");
			return false;
			}

		$db_results = mysql_query($sql, $conf['dbh']);
		// Dump the helps into a array
		while ($results = mysql_fetch_object($db_results))
		{
			$help_item = new Help($results->ident);
			$help_objects[] = $help_item;
		}	
		return $help_objects;	

	} // view_help

	// Display all help topics as <option> </option>
	function display_help_select()
	{

		global $conf, $user;
		// setup the query
		$sql = "SELECT ident FROM help order by ident ASC";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($data = mysql_fetch_object($db_results))
			{
			$help .= "<option value=\"$data->ident\">$data->ident</option>\n";
			}
	return $help;			

	} // display_help_select

	// Delete help, requires ident
	function delete_help ($help_ident)
	{
		global $conf, $user;
		
		// Make sure they are an administrator
		if (!$user->is_admin)
			{
			$conf['error']->add_error('help_delete', "Error deleting help document you do not have sufficant privledges");
			return false;
			}
		
		$sql = "DELETE FROM help WHERE ident='$help_ident' LIMIT 1";
		$db_results = mysql_query($sql, $conf['dbh']);
		if (!$db_results)
			{
			$error = mysql_error();			
			$conf['error']->add_error('help_delete', "The following error occured while trying to delete the help document: $error");
			}
	} // delete_help
	
	// Depreciated use show_link
	function show_help_link ($help_ident, $help_link_text = 0)
	{

		$this->show_link($help_ident,$help_link_text);

	} // show_help_link
	/*!
		@function show_link
		@discussion shows the help link, replaced show_help_link
	*/
	function show_link($help_ident, $help_link_text=0) {
		global $conf, $user;

		$this->get_help($help_ident);
		// just create the approiate link to help.php
		if ($help_link_text == "0" and !$user->is_admin and $this->content)
			{
			$link = $conf['web_path'] . "/help.php?ident=$help_ident";
			echo "<a href=\"javascript:Start('$link');\">[?]</a> ";	
			}
		elseif ($help_link_text != "0" and !$user->is_admin and $this->content) 
			{
			$link = $conf['web_path'] . "/help.php?ident=$help_ident";
			echo "<a href=\"javascript:Start('$link');\">$help_link_text</a> ";
			}
		elseif (!$user->is_admin and !$this->content)
			{
			echo "&nbsp;&nbsp;&nbsp;";
			}
		elseif ($user->is_admin and ($this->content))
			{
			$link = $conf['web_path'] . "/help.php?ident=$help_ident";
			echo "<a href=\"javascript:Start('$link');\">[?]</a>&nbsp;&nbsp;";	
			echo "<a href=\"" . $conf['web_path'] . "/help.php?action=edit&amp;ident=$help_ident\">[E]</a> ";
			}
		elseif ($user->is_admin)
			{
			echo "<a href=\"" . $conf['web_path'] . "/help.php?action=edit&amp;ident=$help_ident\">[N]</a> ";
			}
	} // show_link

	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print("Help: id -> $this->id, ident -> $this->ident, <br /><br /> content -> $this->content");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
} // class Help

?>
